
Ca ********************************************************************
Ca ********************************************************************
Ca ********************************************************************
Ca ********************************************************************
Ca ********************************************************************

      subroutine yji_ctf2dfit(poly_paras_call, npix_col,npix_row,
     +    num_img,fftSizeCall, pixelSizeCall, voltCall, res_hiCall, 
     +    defMajorCall, defMinorCall, angleCall, ampContrastCall, 
     +    CsCall, packImgCall, chisqCall, auto2DdrawBuf, 
     +    auto2DdataBuf, fftasumCall, hkl_maxCall, 
     +    order_bCall, order_dCall, calcIt, saveFftasum, saveFftasumsq)
C **********************************************************************
C *   1. read images from one image file and do 2D FFT                 *
C *   2. average these 2D FFTs                                         *
C *   3. calculate some stats and writeout                             *
C *                                                                    *
C **********************************************************************
      implicit none
C
      INCLUDE '../include/allprogs.inc'
      include 'mem_time.inc'
C
      Character*8   subname
      DATA PROGNAME / 'fftavgr' /
      DATA subNAME / '    ' /
C
C Local variables, used only in the main routine
C

      double precision amp, MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
C
      real, allocatable :: rffta_omega(:)
      double precision, allocatable :: fftasum(:)
      double precision, allocatable :: fftasumsq(:)
      complex, allocatable :: fft2d(:)
      double precision, allocatable :: da2d(:)
C     real, allocatable :: pixels(:)

      double precision, allocatable :: poly_paras(:)
      double precision, allocatable :: ca1d_avg(:)
      double precision, allocatable :: ca1d_std(:)
C
      character(len=256) infile, outfile
     
      integer npix_col, npix_row, num_img, nrffta_row,nrffta_col,
     +   nrffta_omega, nfc_2d_row, nfc_2d_col, hkl_min, hkl_max,
     +   i, j , mem_size, array_size
      integer astart, aend, i_omega, k, k1, k2, kk, count
      integer itemp, itemp2, poly_orderb, poly_orderd, poly_order
      integer fftSizeCall,m,n
      integer hkl_maxCall, order_bCall, order_dCall
      integer alloc_stat
      integer alloc_stat1, alloc_stat2, alloc_stat3, alloc_stat4
      real    pixelSizeCall, voltCall, res_hiCall
      real    pixels(npix_col,npix_row)
      real    auto2DdrawBuf(512,256)
      real    auto2DdataBuf(512,256)
      double precision    poly_paras_call(1024)
      double precision    fftasumCall(1024*2048)
      real    defMajorCall, defMinorCall, angleCall
      real    ampContrastCall, CsCall, chisqCall
      real    packImgCall(npix_col, npix_row, num_img)
      double precision pixel_size, voltage, res_hi, wavelength,
     +                 a, cs, chisq, defmajor, defminor, angle
      real    img_avg, img_std, rtemp, rtemp1, rtemp2
      real    omega, annual, astep
      double precision minvalue, sumvalue, newangle, a1, a2, 
     +        a1sum, a2sum, a1sqsum, a2sqsum, a1a2sum
      double precision sumtest
      integer jj, annhigh2
      real defmax, fw, fw2, annlow, annlow2, ann
      real angdraw, xx, yy, rx, ry, cosph, sinph, theta1
      real tmp5, tmp6, def, arg1, arg2, ctf, ctf2, B, D
      integer  ii, orderb, orderd, irx, iry
      real xbit, ybit, s
      integer calcIt
      real  saveFftasum(1), saveFftasumsq(1)
      
      real pi, center(2)

      double precision elapsed_time
      integer clock1, clock2, clock3

C *********************************************************************
C *                      Initialization                               *
C *********************************************************************
      test_time   = .true.
      test_memory = .true.
      PI = 3.14159265358979323

Ca      call usage
C
      call system_clock(clock1)
C
C --------------------------------------------------------------------
C     read input image file name and out put file name
Ca  100 print *, 'Enter Input image FILENAME: '
Ca      READ (*,'(A)',ERR=100) infile
Ca      print *, 'Input image FILENAME: ', infile
C
Ca      IMGHEAD.LUNUM = pix_file_unit
Ca      CALL PIF_OPEN (infile, IMGHEAD.LUNUM, 'r')
Ca      CALL PIF_READ_GH (IMGHEAD)
Ca      npix_col  = IMGHEAD.NUMCOLS
Ca      npix_row  = IMGHEAD.NUMROWS
Ca      num_img   = IMGHEAD.nimg
      print *, 'col,row,nimg = ', npix_col,npix_row,num_img

C
Ca  101 print *, 'Enter Output fited FILENAME: '
Ca      READ (*,'(A)',ERR=101) outfile
Ca      print *, 'Output fited FILENAME: ', outfile

C --------------------------------------------------------------------
C     read and determine the fft size
Ca  300 print *, 'Enter FFT size:'
Ca      READ (*,*,ERR=300) itemp
Ca      if (itemp .LT. npix_col) goto 300
      itemp = fftSizeCall
      call TRANS_LENGTH_ESSL( itemp, nrffta_row )
      print *, ' FFT size =',nrffta_row
C 
      nfc_2d_row   = nrffta_row/2
      nfc_2d_col   = nfc_2d_row
      hkl_min      = - nfc_2d_row
      hkl_max      = nfc_2d_row
      hkl_maxCall  = hkl_max
      nrffta_col   = nrffta_row
      nrffta_omega = nrffta_col + 15
C --------------------------------------------------------------------
C     read pixel size 
Ca  301 print *, 'Enter pixel_size (A):'
Ca      READ (*,*,ERR=301) rtemp
Ca      if (rtemp .LE. 0.0) goto 301
      rtemp = pixelSizeCall
      pixel_size = rtemp
      print *, ' pixel_size =', pixel_size
C --------------------------------------------------------------------
C     read voltage 
Ca  302 print *, 'Enter voltage (V):'
Ca      READ (*,*,ERR=302) rtemp
Ca      if (rtemp .LE. 0.0) goto 302
      rtemp = voltCall
      voltage = rtemp
      print *, ' voltage =', voltage
C --------------------------------------------------------------------
C     read guess defocus value
Ca  303 print *, 'Enter guessed defocus values and angle (um, um, deg)'
Ca      READ (*,*,ERR=303) rtemp, rtemp1, rtemp2
Ca      if (rtemp .LE. 0.0 .or. rtemp1 .le. 0.0) goto 303
      rtemp = defMajorCall
      rtemp1 = defMinorCall
      rtemp2 = angleCall
      defmajor = rtemp
      defminor = rtemp1
      angle    = rtemp2
      defmajor = rtemp * 10000.0
      defminor = rtemp1 * 10000.0
      print *,'guessed defocus value =',defmajor, defminor, angle
C --------------------------------------------------------------------
C     read highest resolution you want to fit
Ca  304 print *, 'Enter highest resolution you want to fit (A):'
Ca      READ (*,*,ERR=304) rtemp
Ca      if (rtemp .LT. 2.0*pixel_size) goto 304
      rtemp = res_hiCall
      res_hi = rtemp
      print *, ' highest resolution =', res_hi
C --------------------------------------------------------------------
C     Percentage of Amplitude Contrast & Spherical aberration constant
      A = 0.05
      Cs = 20000000.0
Ca  314 print *,'Enter Amplitude Contrast & Spherical aberration constant'
Ca      print *,'  (e.g. 0.05, 2.0)'
Ca      READ (*,*,ERR=314) rtemp, rtemp1
Ca      if (rtemp .le. 0. .or. rtemp1 .le. 0 ) goto 314
      rtemp = ampContrastCall
      rtemp1 = CsCall
      A   = rtemp
      Cs  = rtemp1
      Cs = Cs * 10000000.0

      print *, 'Percentage Amp Contrast =', A, '  Cs =', Cs
C --------------------------------------------------------------------
C     read The order of polynomial to fit the background B, 
Cji   and The order of polynomial to fit signal strengh decay D
Ca  305 print *,'Enter orders of polynomial to fit Background & Decay:'
Ca      READ (*,*,ERR=305) itemp, itemp2
Ca      if (itemp .LE. 0 .or. itemp2 .le. 0) goto 305
      itemp = 5
      itemp2 = 5
      poly_orderb = itemp
      poly_orderd = itemp2
      order_bCall = poly_orderb
      order_dCall = poly_orderd
      print *, ' Order of Background =', poly_orderb 
      print *, ' Order of signal strengh decay =', poly_orderd 
C --------------------------------------------------------------------
C     read The Initial Parameters for polynomial functions of B & D, 
Cji   we formulate the B and D in the order of x, 2nd order is y, 
Cji   such as order 2:  a0 + a1*y + a2*y*y + a3*x + a4*x*y + a5*x*x  
Cji   such as order 3:  a0 + a1*y + a2*y*y + a3*y*y*y + a4*x + a5*x*y + a6*x*y*y + a7*x*x +a8*x*x*y + a9*x*x*x 
C
      poly_orderb  = (poly_orderb + 1) * (poly_orderb + 2) / 2
      poly_orderd  = (poly_orderd + 1) * (poly_orderd + 2) / 2
      poly_order   = poly_orderb + poly_orderd + 3
      allocate(poly_paras(poly_order), stat=alloc_stat)
Cwei  306 print *,'Enter Initial Parameters B&D for polynomial functions:'
Cwei      READ (*,*,ERR=306) (poly_paras(j),j=1,poly_order-3)
Cwei      print *, 'Initial Parameters B&D for polynomial functions:',
Cwei     +        (poly_paras(j),j=1,poly_order-3)
Cwei  initiate values for poly_paras
      do j = 1, poly_order-3
          poly_paras(j) = 0.0
      enddo
      poly_paras(1) = 1.0
      poly_paras(poly_orderb+1) = 1.0
Cwei      print *, 'Initial Parameters B&D for polynomial functions:',
Cwei     +        (poly_paras(j),j=1,poly_order-3)
Cji   according to the subroutine, the last of parameter is used for defocus value
      poly_paras(poly_order-2) = defmajor
      poly_paras(poly_order-1) = defminor
      poly_paras(poly_order  ) = angle
C --------------------------------------------------------------------
Cji   alloc memory
      allocate(rffta_omega(nrffta_omega), stat=alloc_stat)
Ca      if(alloc_stat > 0) call error(progname, subname,
Ca     +    'Error in allocating memory for nrffta_omega')
      if(alloc_stat > 0) then
         print *, 'Error in allocating memory for nrffta_omega'
      endif
C
      mem_size   = npix_col * npix_row 
Ca    allocate(pixels(mem_size), stat=alloc_stat)
C
Ca      if (alloc_stat > 0) call error_stop (
Ca     +      progname, subname, 'image memory allocation failed')

      mem_pixels_array = 4*mem_size
      mem_total = mem_total + mem_pixels_array
      mem_peak  = max(mem_peak, mem_total)
C      
      mem_size     = (nfc_2d_row +1) * (nfc_2d_col * 2 +1)
      array_size   = mem_size
      allocate(fftasum(mem_size), stat=alloc_stat1)
      allocate(fftasumsq(mem_size), stat=alloc_stat2)
      allocate(fft2d(mem_size), stat=alloc_stat3)
      allocate(da2d(mem_size), stat=alloc_stat4)
Ca      if (alloc_stat1 > 0 .or. alloc_stat2 > 0 
Ca     +  .or. alloc_stat3 > 0 .or. alloc_stat4 > 0) call error_stop(
Ca     +    progname, subname, 'fft space memory allocation failed')
      if (alloc_stat1 > 0 .or. alloc_stat2 > 0 
     +  .or. alloc_stat4 > 0 .or. alloc_stat3 > 0) then
         print *, 'fft space memory allocation failed'
      endif
      mem_cmpt  = 8*mem_size
      mem_total = mem_total + 4*mem_cmpt
      mem_peak  = max(mem_peak, mem_total)
C --------------------------------------------------------------------
      do i = 1, mem_size
         fftasum(i)   = 0.
         fftasumsq(i) = 0.
      enddo
C
      call system_clock(clock2)
      t_init = elapsed_time(clock1, clock2)
C
C *********************************************************************
C *read each image do 2D DFT to fft2d(complex) calculate fftasum and fftasumsq(real)*
C *********************************************************************
C
      call vrffti( nrffta_col, rffta_omega )
      itemp  = npix_row*npix_col

Ca  RWa Nov 2005 Try and optimize this - if we've calculated
Ca  this before then just use that - don't recalc every time 
      if(calcIt .eq. 1) then
         do i = 1, num_img
C
Cji   read one image
Ca        IMGHEAD.IMGNUM = i
Ca        CALL PIF_READ_DH(IMGHEAD)
Ca        call rpifimag_f (itemp, pixels)

            do m=1,npix_row
               do n=1,npix_col
                  pixels(n,m) = packImgCall(n,m,i) 
               enddo
            enddo
Ca         print *, '********************************'
Ca         print *, 'pixels -', pixels(1,1)
Ca         print *, 'pixels -', pixels(1,2)
Ca         print *, 'pixels -', pixels(2,1)
Ca         print *, 'pixels -', pixels(2,2)

C
Cji   do 2D DFT
            
            center(1) = (npix_row - 1)/2.0
            center(2) = (npix_col - 1)/2.0

            call fft_2dfft(pixels, npix_row, npix_col, center,
     +           nrffta_omega, rffta_omega, nrffta_row, nrffta_col,
     +           hkl_max, hkl_max, fft2d)
C
Cji   average them   
            do j = 1, array_size
               amp       = sqrt( real(fft2d(j))**2 + aimag(fft2d(j))**2)
               fftasum(j) = fftasum(j) + amp
               fftasumsq(j) = fftasumsq(j) + amp**2
               saveFftasum(j) = fftasum(j)
               saveFftasumsq(j) = fftasumsq(j)
            enddo
C
         enddo
      else
         do j = 1, array_size
            fftasum(j) = saveFftasum(j) 
            fftasumsq(j) = saveFftasumsq(j) 
         enddo
      endif   ! if(calcIt .eq. 1) 

C *********************************************************************
Ca      call pif_close (pix_file_unit)
      deallocate(rffta_omega)
      deallocate(fft2d)
Ca    deallocate(pixels)
      mem_total = mem_total - mem_pixels_array - mem_cmpt
C *********************************************************************
Cji   caluate some stats, we use fftasum to store avg, fftasumsq store std
C *********************************************************************
C
      MAP_MIN = fftasum(1)/num_img
      MAP_MAX = fftasum(1)/num_img
      MAP_AVG = 0. 
      MAP_STD = 0.
      do i = 1, array_size
         fftasum(i) = fftasum(i) / num_img
         amp = fftasumsq(i)/num_img - fftasum(i)**2
         if ( amp .gt.0 ) then 
            fftasumsq(i) = sqrt(amp)
         else
            fftasumsq(i) = 0
         endif
         MAP_MIN = MIN(MAP_MIN, fftasum(i))
         MAP_MAX = MAX(MAP_MAX, fftasum(i))
         MAP_AVG = MAP_AVG + fftasum(i)
         MAP_STD = MAP_STD + fftasum(i)**2
      enddo
C
      MAP_AVG = MAP_AVG / array_size
      amp     = MAP_STD / array_size - MAP_AVG**2
      if (amp.gt.0 ) MAP_STD = sqrt(amp)
C
      do i = 1, array_size
        fftasum(i) = fftasum(i) / MAP_AVG
        fftasumsq(i) = fftasumsq(i) / MAP_AVG
        fftasumCall(i) = fftasum(i)
      enddo
Cji      call doutimg(fftasum,hkl_min,hkl_max,"ampfile2")
C
       PRINT *, ' '
       WRITE(*,1000)
       WRITE(*,1001)
       WRITE(*,1003)
 1000  FORMAT('                  STATICS: averaged FFT')
 1001  FORMAT('FFTSIZE   MINIMUM     MAXIMUM        AVERAGE        STD')
 1003  FORMAT('-------------------------------------------------------')
       WRITE(*,1002)hkl_max, MAP_MIN, MAP_MAX, MAP_AVG, MAP_STD
 1002 FORMAT (I5,2(2x, F10.3),5x, F10.3, 1x, F10.3)
C
C *********************************************************************
Cji   calculate ctf values
Cji   note some different with ctf_para.f, because of the unit
      wavelength = 12.264264967 / 
     +             sqrt (voltage + 0.9784663543E-6 * voltage**2 )
C
C *********************************************************************
Cwei findout the inner-most first zero  based on the maximum def value 
C
C
      mem_total = mem_total - mem_cmpt
      deallocate(da2d)
C
      call cmpt_fit(fftasum, fftasumsq, hkl_max, res_hi,
     +              poly_paras, poly_order, poly_orderb, poly_orderd,
     +              wavelength, A, Cs, pixel_size, chisq,auto2DdrawBuf,
     +              auto2DdataBuf)
C
C --------------------------------------------------------------------
Cji   print out the result and write files
Ca      OPEN (UNIT=13, FILE=outfile, ERR=960)
Ca      goto 961
C
Ca  960 print *,  'Error in opening output file'
C
Cji   open output file ok, print out the head for orientation file.
C
  961 defmajor = poly_paras(poly_order-2) /10000.
      defminor = poly_paras(poly_order-1) /10000.
      angle    = poly_paras(poly_order)

      call robStuffPolyParas(poly_paras_call, poly_paras, poly_order)

      angle    = angle * 180.0 / 3.14159265358979323
      if (defmajor.lt.defminor) then
         rtemp = defmajor
         defmajor = defminor
         defminor = rtemp
         if (angle.gt.0.0) then 
            angle = angle - 90.0
         else
            angle = angle + 90.0
         endif
      endif
	if (angle.lt.0.0) then
            angle = angle +360.
        endif
Ca ********************************************************
Ca  Stuff the display buffer for robEM
Ca ********************************************************
Ca        call stuffRobemBuf(auto2DdrawBuf, poly_paras, poly_order,
Ca     +              wavelength, pixel_size, Cs, A, 
Ca     +              poly_orderb, poly_orderd)


Ca      WRITE(13,1009) infile
Ca 1009 FORMAT(64a)
Ca      WRITE(13,1010) pixel_size, 1, voltage, A,
Ca     +            defmajor, defminor, angle, Cs/10000000
Ca 1010 FORMAT (1X,F8.4,',',I2,',',F10.1,',',4(F10.4,','),F8.2)
Ca      close(UNIT=13)
C
C --------------------------------------------------------------------
      deallocate(fftasum)
      deallocate(fftasumsq)
      deallocate(poly_paras)
      mem_total = mem_total - 2*mem_cmpt

      call system_clock(clock3)
      t_interp = elapsed_time(clock2, clock3)
C
C *********************************************************************
C
       if (mem_total .ne. 0) print *,'mem_total=',mem_total,
     +  'At the end, mem_total should be 0!!!'
C
       time = t_init + t_interp
C
       if (test_time)
     +    print 40, 0, t_init,
     +                   t_interp,
     +                   time
  40      format (/ 'Node ', i3,
     +          ' Time used in initialization                      =',
     +        f15.4, ' ' / 8x,
     +          ' Time used in read image & 2DFFT & factors        =',
     +        f15.4, ' ' / 8x,
     +          ' Total time used                                  =',
     +        f15.4)
C
C     Print memory allocating message.
C
       if (test_memory) print 60, 0, mem_peak,
     +       mem_pixels_array, mem_cmpt ,mem_cmpt_intrps
   60    format(/ 'Node ', i3, ' Memory allocation in BYTES:', /
     +                  8x, ' Peak memory allocated   =', f18.1 /
     +                  8x, ' Memory for 3D Map       =', f18.1 /
     +                  8x, ' Memory for 3D FFT       =', f18.1 /
     +                  8x, ' Memory used in CMPCC    =', f18.1 )
C
      print *, '**********finished nicely**********'
Ca      stop
      defMajorCall = defmajor
      defMinorCall = defminor
      angleCall = angle
      chisqCall = chisq

      return
      end


Ca***********************************************************************
Ca Try stuffing the array 
Ca***********************************************************************
      subroutine robStuffPolyParas(poly_paras_call, 
     +    poly_paras, poly_order)
      integer i,poly_order
      double precision poly_paras(poly_order),poly_paras_call(1024)

      do i = 1, poly_order
         poly_paras_call(i) = poly_paras(i)
      enddo

      return
      end


Ca***********************************************************************
Ca Calc s,b,d,etc. arrays based on draw angle.
Ca***********************************************************************
      subroutine robangle_curves(angdrawCall, angle, poly_paras_call,
     +    defmajorCall,defminorCall,hkl_maxCall,order_bCall,
     +    order_dCall, fftasumCall, voltCall, ampContrastCall, 
     +    csCall, pixelCall,
     +    sCall, sminusbCall, ctfsqCall, dCall, bCall
     +    
     +                             )

      real theta1, PI,cosph,sinph,defmajorCall,defminorCall
      real xx,yy,tmp6,rx,ry,tmp5,arg1,arg2,B,D,fw,fw2
      real ctf,ctf2, ampContrastCall, csCall
      integer  ii, orderb, orderd, irx, iry
      integer  order_bCall, order_dCall
      real xbit, ybit, s
      real angdrawCall, voltCall, pixelCall
      real sCall(1024),sminusbCall(1024),ctfsqCall(1024)
      real dCall(1024),bCall(1024)
      integer hkl_maxCall,hkl_max,kk,i,j
      double precision    fftasumCall(1024*2048)
      double precision poly_paras_call(1024)
      double precision pixel_size, voltage, res_hi, wavelength,
     +                 a, cs, chisq, defmajor, defminor, angle
     +                 angdraw


      PI = 3.14159265358979323
      pixel_size = pixelCall
      A = ampContrastCall
      Cs = csCall
      hkl_max = hkl_maxCall
      orderb = order_bCall
      orderd = order_dCall
      defmajor = defmajorCall
      defminor = defminorCall
      voltage = voltCall
      wavelength = 12.264264967 / 
     +             sqrt (voltage + 0.9784663543E-6 * voltage**2 )

      angdraw = angdrawCall
      theta1= angdraw-angle
      theta1=theta1*PI/180.0
      cosph = cos(theta1)
      sinph = sin(theta1)
      def   = defmajor*10000.*cosph*cosph + defminor*10000.*sinph*sinph
      angdraw = angdraw*PI/180.0
      xx = cos(angdraw)
      yy = sin(angdraw)
      if (xx.lt.0.0) then
         xx = -1.0*xx
         yy = -1.0*yy
      endif
      do i=1,hkl_max
         rx = xx*i
         ry = yy*i
         tmp6 = 0.0
         kk=1
         arg1 = 1
         do j=1, orderb+1
            arg2 =  1
            do k =1, orderb-j+2
               tmp5= arg1 * arg2
               tmp6 =tmp6+poly_paras_call(kk)*tmp5
               arg2= arg2*ry
               kk = kk+1
            enddo
            arg1=arg1*rx
         enddo
         B = tmp6
         tmp6=0.0
         arg1 = 1
         do j=1, orderd+1
            arg2 =  1
            do k =1, orderd-j+2
               tmp5= arg1 * arg2
               tmp6 =tmp6+poly_paras_call(kk)*tmp5
               arg2= arg2*ry
               kk = kk+1
            enddo
            arg1=arg1*rx
         enddo
         D = tmp6
c     print *,'   b=',b,'  d=',d
         
         fw =wavelength*i/(hkl_max*2.0* pixel_size )
         fw2= fw*fw
         tmp5 = wavelength
         theta1 = PI*2.0*(Cs*fw2*fw2/4.0-def*fw2/2.0)/tmp5
         tmp5 = A*A
         ctf = sqrt(1.0-tmp5)*sin(theta1)-A*cos(theta1)
         ctf2 = ctf*ctf
         irx =rx
         iry =ry
         xbit = abs(rx - irx)
         ybit = abs(ry - iry)
         s = 0.0
         if(ry.ge.0.0) then
            ii = (iry+hkl_max)*(hkl_max+1)+irx+1
            s =s+ fftasumCall(ii)*(1.0-xbit)*(1.0-ybit)
            ii = (iry+1+hkl_max)*(hkl_max+1)+irx+1
            s =s+ fftasumCall(ii)*(1.0-xbit)*ybit
            ii = (iry+hkl_max)*(hkl_max+1)+irx+1+1
            s =s+ fftasumCall(ii)*xbit*(1.0-ybit)
            ii = (iry+1+hkl_max)*(hkl_max+1)+irx+1+1
            s =s+ fftasumCall(ii)*xbit*ybit
c     print *, 'irx=',irx+1,' iry=', iry+1,' ii=',ii
c     print *, 'ii=', ii, '  fftasumCall=', fftasumCall(ii), '  s=',s
         else
            ii = (iry+hkl_max)*(hkl_max+1)+irx+1
            s =s+ fftasumCall(ii)*(1.0-xbit)*(1.0-ybit)
            ii = (iry-1+hkl_max)*(hkl_max+1)+irx+1
            s =s+ fftasumCall(ii)*(1.0-xbit)*ybit
            ii = (iry+hkl_max)*(hkl_max+1)+irx+1+1
            s =s+ fftasumCall(ii)*xbit*(1.0-ybit)
            ii = (iry-1+hkl_max)*(hkl_max+1)+irx+1+1
            s =s+ fftasumCall(ii)*xbit*ybit
         endif
         sCall(i) = s
         sminusbCall(i) = s - B
         ctfsqCall(i) = ctf2
         dCall(i) = D
         bCall(i) = B
      enddo
      
      return 
      end
